//=========================================================================
//
//	FILE:				CP_NibXML_Application.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			Application class for the CP_CP_NibXML demo app.
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 10 $
//						Latest Checkout:  $Date: 2005-08-30 20:32:29 -0700 (Tue, 30 Aug 2005) $
//
//=========================================================================

#ifndef _H_CP_NibXML_Application
#define _H_CP_NibXML_Application
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

#include "CP_NibXML.h"

	// CPLAT_Framework
#include "CP_Application.h"
#include "CP_DataValueHolder.h"
#include "CP_DocumentPolicy_None.h"
#include "CP_FileSystemSpec.h"
#include "CP_OSStatus.h"
#include "CP_PrintPolicy_None.h"
#include "CP_Types.h"
#include "CP_UndoPolicy_None.h"

/*!
*	@class		CP_NibXML_Application
*	@brief		Application class for the NibXML demo.
*
*				This demo demonstrate the use of converting a MacOS Nib file, using the
*				CPLAT NibToXML tool to convert the file to a form of XML that is used
*				by the CPLAT framework. By converting the XML file into XML resources the
*				nibs UI can be used with the Windows and Linux versions of CPLAT.
*/
class CP_NibXML_Application : public CPLAT::CP_Application<CPLAT::CP_DocumentPolicy_None, CPLAT::CP_PrintPolicy_None, CPLAT::CP_UndoPolicy_None>
{
public:
	//! @name Constructor / Destructor
	//@{
	//! Constructor.
										CP_NibXML_Application();
	//! Destructor.
	virtual								~CP_NibXML_Application() throw();
	//@}
			
protected:
	//! @name AboutBox
	//@{
	virtual	CPLAT::CP_String			GetAboutBoxDescription() const;
	//@}

	//! @name Commands
	//@{
	virtual	void						HandleOpenApplication();
	virtual	void						HandleNewUpdateCommandStatus(
												CPLAT::CP_CommandStatus& inOutCommandStatus,
												bool& /*inOutWasHandled*/,
												CPLAT::CP_CommandNo& /*inCommandNo*/ )		{ inOutCommandStatus.SetIsEnabled( true ); }
	virtual	void						HandleNew(
												CPLAT::OSStatus& inOutStatus,
												CPLAT::CP_CommandNo& inCommandNo );
	//@}

private:
	//! @name Slots
	//@{
			void						HandlePopupCommand(
												CPLAT::OSStatus& inOutStatus,
												CPLAT::CP_CommandNo& inCommandNo );
	//@}

	// class data
protected:
	
//========================================================================
// Platform specific routines
//========================================================================
#if TARGET_OS_MAC
#endif

#if TARGET_OS_WIN32
#endif

#if TARGET_OS_LINUX
#endif
};

#endif	// _H_CP_NibXML_Application

