//=========================================================================
//
//	FILE:				CP_DefaultHeap.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			Create the default heap where memory allocations come from.
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 2 $
//						Latest Checkout:  $Date: 2004-12-21 19:40:38 -0800 (Tue, 21 Dec 2004) $
//
//=========================================================================
#ifndef _H_CP_DefaultHeap
#define _H_CP_DefaultHeap
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

	// CPLAT_Framework
#include "CP_Heap.h"
#include "CP_Types.h"

CPLAT_Begin_Namespace_CPLAT

/*!
*	@class		CP_DefaultHeap
*	@brief		Create the default heap where memory allocations come from. 
*/
class CP_EXPORT CP_DefaultHeap : public CP_Heap
{
public:
	//! @name Constructor / Destructor
	//@{
	//! Constructor.
										CP_DefaultHeap();
	//! Destructor.
	virtual								~CP_DefaultHeap();
	//@}

protected:

//========================================================================
// Platform specific routines
//========================================================================
#if TARGET_OS_MAC
#endif

#if TARGET_OS_WIN32
#endif
};

CPLAT_End_Namespace_CPLAT

#endif	// _H_CP_DefaultHeap


