//=========================================================================
//
//	FILE:				CP_FontMetrics.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			Class to provide font metric information about a CP_Font.
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 2 $
//						Latest Checkout:  $Date: 2004-12-21 19:40:38 -0800 (Tue, 21 Dec 2004) $
//
//=========================================================================
#ifndef _H_CP_FontMetrics
#define _H_CP_FontMetrics
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

	// CPLAT_Framework
#include "CP_Font.h"
#include "CP_M_ReferenceCounted.h"

CPLAT_Begin_Namespace_CPLAT

/*!
*	@class		CP_FontMetrics
*	@brief		Class to provide font metric information about a CP_Font.
*/
class CP_EXPORT CP_FontMetrics : public CP_M_RefCounted
{
public:
	//! @name Constructor / Destructor
	//@{
	//! Constructor.
										CP_FontMetrics( CP_Font *inOwnerFont );
	//! Destructor.
	virtual								~CP_FontMetrics() throw();
	//@}
			
	//! @name Getters
	//@{
			SInt16						Height();
			SInt16						AscentHeight();
	//@}

	//! @name Measurement
	//@{
			SInt16						CharWidth( char inChar );
			SInt32						TextWidth( const CP_String& inText );
			SInt32						TextWidth(
												char *inText,
												SInt32 inLineStart,
												SInt32 inLineLength );
	//@}

protected:

	// class data
protected:
	CP_Font								*fOwnerFont;
	
//========================================================================
// Platform specific routines
//========================================================================
#if TARGET_OS_MAC
#endif

#if TARGET_OS_WIN32
#endif

#if TARGET_OS_LINUX
#endif
};

CPLAT_End_Namespace_CPLAT

#endif	// _H_CP_FontMetrics

