//=========================================================================
//
//	FILE:				CP_PrintPolicy_None.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			DESCRIBE CLASS HERE
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 194 $
//						Latest Checkout:  $Date: 2005-05-25 22:20:49 -0700 (Wed, 25 May 2005) $
//
//=========================================================================
#ifndef _H_CP_PrintPolicy_None
#define _H_CP_PrintPolicy_None
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

	// CPLAT_Framework
#include "CP_M_CommandHandler.h"
#include "CP_NoCopy.h"
#include "CP_Printer.h"

CPLAT_Begin_Namespace_CPLAT

/*!
*	\class	CP_PrintPolicy_None
*	\brief	1 LINE BRIEF DESCRIPTION HERE
*	
*	DETAILED DESCRIPTION BEGINS HERE
*/

class CP_EXPORT CP_PrintPolicy_None : CP_NoCopy
{
public:
											// Construction / destruction
										CP_PrintPolicy_None()							{}
	virtual								~CP_PrintPolicy_None()							{}
			
	//! @name Commands
	//@{
			void						HandlePageSetupUpdateCommandStatusCommand(
												CP_CommandStatus& inOutCommandStatus,
												bool& /*inOutWasHandled*/,
												CP_CommandNo& /*inCommandNo*/ )			{ inOutCommandStatus.SetIsEnabled( false ); }
			void						HandlePageSetupCommand(
												OSStatus& inOutStatus,
												CP_CommandNo& /*inCommandNo*/ )			{ inOutStatus = CP_noErr; }
			void						HandlePrintUpdateCommandStatusCommand(
												CP_CommandStatus& inOutCommandStatus,
												bool& /*inOutWasHandled*/,
												CP_CommandNo& /*inCommandNo*/ )			{ inOutCommandStatus.SetIsEnabled( false ); }
			void						HandlePrintCommand(
												OSStatus& inOutStatus,
												CP_CommandNo& /*inCommandNo*/,
												CP_PrintSignal */*inPrintSignal*/ )		{ inOutStatus = CP_noErr; }
	//@}

			void						Cleanup()										{}
			
			CP_Printer					*GetPrinter()									{ return( NULL ); }

			CP_Window					*GetParentWindow()								{ return( fParentWindow ); }
			void						SetParentWindow( CP_Window *inParentWindow )	{ fParentWindow = inParentWindow; }

protected:

	// class data
protected:
	CP_Window							*fParentWindow;

//========================================================================
// Platform specific routines
//========================================================================
#if TARGET_OS_MAC
#endif

#if TARGET_OS_WIN32
#endif

#if TARGET_OS_LINUX
#endif
};

CPLAT_End_Namespace_CPLAT

#endif	// _H_CP_PrintPolicy_None
