//=========================================================================
//
//	FILE:				CP_SMTPResponse.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			Base class to handle responses from our SMTP servers.
//
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 2 $
//						Latest Checkout:  $Date: 2004-12-21 19:40:38 -0800 (Tue, 21 Dec 2004) $
//
//=========================================================================
#ifndef _H_CP_SMTPResponse
#define _H_CP_SMTPResponse
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

	// CPLAT_Framework
#include "CP_InternetResponse.h"
#include "CP_Socket.h"
#include "CP_String.h"
#include "CP_Types.h"

CPLAT_Begin_Namespace_CPLAT

	// FTP status code length
const size_t kCP_SMTP_STATUS_CODE_LENGTH					= 3;

/*!
*	@class		CP_POP3Response
*	@brief		A CP_InternetResponse class to handle SMTP server responses. This class is designed
*				to be used with the CP_SMTP class.
*/
class CP_EXPORT CP_SMTPResponse : public CP_InternetResponse
{
public:
	enum
	{
		kCP_SMTP__ServiceReady		= 220,
		kCP_SMTP__ServiceClose		= 221,
		kCP_SMTP__RequestOK 		= 250,
		kCP_SMTP__NotLocal			= 251,
		kCP_SMTP__StartMail			= 354
	};

	//! @name Constructor / Destructor
	//@{
	//! Constructor.
										CP_SMTPResponse( CP_Socket *inSocket );
										CP_SMTPResponse( const CP_SMTPResponse& inResponse );
	//! Destructor.
	virtual								~CP_SMTPResponse() throw();
	//@}
				
	//! @name Server response
	//@{
	virtual		bool					GetServerResponse();
	//@}

protected:
	
private:

	// class data
protected:

//========================================================================
// Platform specific routines
//========================================================================
#if TARGET_OS_MAC
#endif

#if TARGET_OS_WIN32
#endif

#if TARGET_OS_LINUX
#endif
};

CPLAT_End_Namespace_CPLAT

#endif	// _H_CP_SMTPResponse


