//=========================================================================
//
//	FILE:				CP_CommandNos.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			Definitions for commands numbers used in the CPLAT framework.
//						Convenience functions for conversion from various
//						platforms command numbers to CPLAT command nos.
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 2 $
//						Latest Checkout:  $Date: 2004-12-21 19:40:38 -0800 (Tue, 21 Dec 2004) $
//
//=========================================================================
#ifndef _H_CP_CommandNos
#define _H_CP_CommandNos
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

	// CPLAT_Framework
#include "CP_Types.h"

CPLAT_Begin_Namespace_CPLAT

/*!
*	Definitions for commands numbers used in the CPLAT framework.
*/

const CP_CommandNo CP_CMD_NoCommand								= 0;

	// File menu commands
const CP_CommandNo CP_CMD_New									= 1;
const CP_CommandNo CP_CMD_Open									= 2;
const CP_CommandNo CP_CMD_Close									= 3;
const CP_CommandNo CP_CMD_Save									= 4;
const CP_CommandNo CP_CMD_SaveAs								= 5;
const CP_CommandNo CP_CMD_Revert								= 6;
const CP_CommandNo CP_CMD_PageSetup								= 7;
const CP_CommandNo CP_CMD_Print									= 8;
const CP_CommandNo CP_CMD_Quit									= 9;

	// Edit menu commands
const CP_CommandNo CP_CMD_Undo									= 10;
const CP_CommandNo CP_CMD_Cut									= 11;
const CP_CommandNo CP_CMD_Copy									= 12;
const CP_CommandNo CP_CMD_Paste									= 13;
const CP_CommandNo CP_CMD_Clear									= 14;
const CP_CommandNo CP_CMD_SelectAll								= 15;
const CP_CommandNo CP_CMD_Redo									= 16;

const CP_CommandNo CP_CMD_Preferences							= 17;

const CP_CommandNo CP_CMD_About									= 18;

	// Debug menu commands
const CP_CommandNo CP_CMD_DebugMenu_ShowMessages				= 900;

	// Misc commands
const CP_CommandNo CP_CMD_CommandOK								= CP_FOUR_CHAR_CODE('ok  ');
const CP_CommandNo CP_CMD_CommandCancel							= CP_FOUR_CHAR_CODE('not!');

//=========================================================================
//	Helper functions for converting from an OS command to a CP_CommandNo
//=========================================================================
namespace CP_CommandNos
{
	#if TARGET_OS_MAC && TARGET_API_MAC_CARBON
		CP_CommandNo	CP_HICommandToCP_CommandNo( ::HICommand inHICommand );
		::HICommand		CP_CP_CommandNoToHICommand( CP_CommandNo inCP_CommandNo );
	#endif	// TARGET_OS_MAC && TARGET_API_MAC_CARBON
}

CPLAT_End_Namespace_CPLAT

#endif	// _H_CP_CommandNos

