//=========================================================================
//
//	FILE:				CP_SystemFontNames.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			Definitions for common system fonts.
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 2 $
//						Latest Checkout:  $Date: 2004-12-21 19:40:38 -0800 (Tue, 21 Dec 2004) $
//
//=========================================================================
#ifndef _H_CP_FontNames
#define _H_CP_FontNames
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

	// CPLAT_Framework
#include "CP_String.h"
#include "CP_Types.h"

CPLAT_Begin_Namespace_CPLAT

#if TARGET_OS_MAC
	const CP_String kCP_SystemFont						= "systemFont"; 
	const CP_String kCP_ApplicationFont					= "applFont";

	const CP_String kCP_SystemLarge						= "system large";
	const CP_String kCP_SystemSmall						= "system small";
	const CP_String kCP_SystemSmallBold					= "system small bold";


	const CP_String kCP_SystemEmphasized				= "systemFontEmphasized"; 
	const CP_String kCP_SystemEmphasizedSmall			= "smallSystemFontEmphasized"; 
	const CP_String kCP_Lable							= "labelFont"; 
#endif

#if TARGET_OS_WIN32
	const CP_String kCP_SYSTEM_FONT						= "SYSTEM_FIXED"; 
	const CP_String kCP_APPLICATION_FONT				= "SYSTEM_FIXED";

	const CP_String kCP_SYSTEM_LARGE					= "MS Sans Serif";
	const CP_String kCP_SYSTEM_SMALL					= "MS Sans Serif";
	const CP_String kCP_SYSTEM_SMALL_BOLD				= "MS Sans Serif";

	const CP_String kCP_SYSTEM_EMPH_FONT				= "SYSTEM_FIXED"; 
	const CP_String kCP_SMALL_SYSTEM_FONT				= "MS Sans Serif"; 
	const CP_String kCP_SMALL_SYSTEM_EMPH_FONT			= "MS Sans Serif"; 
	const CP_String kCP_LABEL_FONT						= "MS Sans Serif"; 
#endif

#if TARGET_OS_LINUX
	const CP_String kCP_SYSTEM_FONT						= "System"; 
	const CP_String kCP_APPLICATION_FONT				= "System";

	const CP_String kCP_SYSTEM_LARGE					= "MS Sans Serif";
	const CP_String kCP_SYSTEM_SMALL					= "MS Sans Serif";
	const CP_String kCP_SYSTEM_SMALL_BOLD				= "MS Sans Serif";

	const CP_String kCP_SYSTEM_EMPH_FONT				= "systemFontEmphasized"; 
	const CP_String kCP_SMALL_SYSTEM_FONT				= "smallSystemFont"; 
	const CP_String kCP_SMALL_SYSTEM_EMPH_FONT			= "smallSystemFontEmphasized"; 
	const CP_String kCP_LABEL_FONT						= "labelFont"; 
#endif

CPLAT_End_Namespace_CPLAT

#endif	// _H_CP_FontNames
