//=========================================================================
//
//	FILE:				CP_Document_tmpl.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			DESCRIBE CLASS HERE
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 194 $
//						Latest Checkout:  $Date: 2005-05-25 22:20:49 -0700 (Wed, 25 May 2005) $
//
//=========================================================================
#ifndef _H_CP_Document_tmpl
#define _H_CP_Document_tmpl
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

	// CPLAT_Framework
#include "CP_Document.h"
#include "CP_Events.h"
#include "CP_Events_Defines.h"

CPLAT_Begin_Namespace_CPLAT

//=========================================================================
//	FUNCTION:	CP_Document
//	
//	VISIBLITY:	Public
//=========================================================================
template <class UNDO_POLICY, class PRINT_POLICY>
CP_Document<UNDO_POLICY, PRINT_POLICY>::CP_Document(
	CP_ScriptableObject *inContainer, SInt32 inDocType )
		: CP_Document_Base( inContainer, inDocType )
{
#if 0
	CP_RegisterUpdateStatusHandler( CP_CMD_PageSetup )->connect( CPLAT::CP_SigSlot::slot(this, &CP_Document::HandlePageSetupUpdateCommandStatusCommand) );
	CP_RegisterCommandHandler( CP_CMD_PageSetup )->connect( CPLAT::CP_SigSlot::slot(this, &CP_Document::HandlePageSetupCommand) );

	CP_RegisterUpdateStatusHandler( CP_CMD_Print )->connect( CPLAT::CP_SigSlot::slot(this, &CP_Document::HandlePrintUpdateCommandStatusCommand) );
	CP_RegisterCommandHandler( CP_CMD_Print )->connect( CPLAT::CP_SigSlot::slot(this, &CP_Document::HandlePrintCommand) );

	#if TARGET_OS_WIN32
		CP_RegisterUpdateStatusHandler( CP_CMD_Redo )->connect( CPLAT::CP_SigSlot::slot(this, &CP_Document::HandleRedoCommandStatus) );
		CP_RegisterCommandHandler( CP_CMD_Redo )->connect( CPLAT::CP_SigSlot::slot(this, &CP_Document::HandleRedoCommand) );
	#endif
#endif	// #if 0
	
		// setup the printing slot to be called when/if the user requests
		// to print a document.
	fPrintSignal.connect( CPLAT::CP_SigSlot::slot( this, &CP_Document::HandlePrinting) );
}

//=========================================================================
//	FUNCTION:	CP_Document
//	
//	VISIBLITY:	Public
//=========================================================================
template <class UNDO_POLICY, class PRINT_POLICY>
CP_Document<UNDO_POLICY, PRINT_POLICY>::~CP_Document() throw()
{
}

#if TARGET_CC_METROWERKS
#pragma mark === Printing ==
#endif

//=========================================================================
//	FUNCTION:	HandlePageSetupUpdateCommandStatusCommand
//	
//	VISIBLITY:	Protected
//=========================================================================
template <class UNDO_POLICY, class PRINT_POLICY>
void CP_Document<UNDO_POLICY, PRINT_POLICY>::HandlePageSetupUpdateCommandStatusCommand(
	CP_CommandStatus& inOutCommandStatus, bool& inOutWasHandled, CP_CommandNo& inCommandNo )
{
	fPrintPolicy.HandlePageSetupUpdateCommandStatusCommand( inOutCommandStatus, inOutWasHandled, inCommandNo );
}

//=========================================================================
//	FUNCTION:	HandlePageSetupCommand
//	
//	VISIBLITY:	Protected
//=========================================================================
template <class UNDO_POLICY, class PRINT_POLICY>
void CP_Document<UNDO_POLICY, PRINT_POLICY>::HandlePageSetupCommand( OSStatus& inOutStatus,
	CP_CommandNo& inCommandNo )
{
	fPrintPolicy.HandlePageSetupCommand( inOutStatus, inCommandNo );
}

//=========================================================================
//	FUNCTION:	HandlePrintUpdateCommandStatusCommand
//	
//	VISIBLITY:	Protected
//=========================================================================
template <class UNDO_POLICY, class PRINT_POLICY>
void CP_Document<UNDO_POLICY, PRINT_POLICY>::HandlePrintUpdateCommandStatusCommand(
	CP_CommandStatus& inOutCommandStatus, bool& inOutWasHandled, CP_CommandNo& inCommandNo )
{
	fPrintPolicy.HandlePrintUpdateCommandStatusCommand( inOutCommandStatus, inOutWasHandled, inCommandNo );
}

//=========================================================================
//	FUNCTION:	HandlePrintCommand
//	
//	VISIBLITY:	Protected
//=========================================================================
template <class UNDO_POLICY, class PRINT_POLICY>
void CP_Document<UNDO_POLICY, PRINT_POLICY>::HandlePrintCommand( OSStatus& inOutStatus,
	CP_CommandNo& inCommandNo )
{
	fPrintPolicy.HandlePrintCommand( inOutStatus, inCommandNo, &fPrintSignal );
}

#if TARGET_CC_METROWERKS
#pragma mark === Undo ==
#endif

//=========================================================================
//	FUNCTION:	HandleUndoEvent
//	
//	VISIBLITY:	Public
//=========================================================================
template <class UNDO_POLICY, class PRINT_POLICY>
void CP_Document<UNDO_POLICY, PRINT_POLICY>::HandleUndoEvent( CP_Event_Base& inEvent )
{
	CP_Event<kCP_EventClassAction, kCP_Event_UndoAction>		undoEvent( inEvent );

	fUndoPolicy.HandlePostCommand( undoEvent.fUndoAction );
}

//=========================================================================
//	FUNCTION:	HandleUndoCommandStatus
//	
//	VISIBLITY:	Private
//=========================================================================
template <class UNDO_POLICY, class PRINT_POLICY>
void CP_Document<UNDO_POLICY, PRINT_POLICY>::HandleUndoCommandStatus( CP_CommandStatus& inOutCommandStatus,
	bool& inOutResult, CP_CommandNo& inCommand )
{
	fUndoPolicy.UpdateUndoMenuStatus( inOutCommandStatus, inOutResult, inCommand );
	
	inOutResult = true;
}

//=========================================================================
//	FUNCTION:	HandleUndoCommand
//	
//	VISIBLITY:	Private
//=========================================================================
template <class UNDO_POLICY, class PRINT_POLICY>
void CP_Document<UNDO_POLICY, PRINT_POLICY>::HandleUndoCommand( OSStatus& inOutStatus,
	CP_CommandNo& /*inCommand*/ )
{	
	fUndoPolicy.HandleUndoCommand( inOutStatus );
}

//=========================================================================
//	FUNCTION:	HandleRedoCommandStatus
//	
//	VISIBLITY:	Private
//=========================================================================
template <class UNDO_POLICY, class PRINT_POLICY>
void CP_Document<UNDO_POLICY, PRINT_POLICY>::HandleRedoCommandStatus( CP_CommandStatus& inOutCommandStatus,
	bool& inOutResult, CP_CommandNo& inCommand )
{
	fUndoPolicy.UpdateRedoMenuStatus( inOutCommandStatus, inOutResult, inCommand );
	
	inOutResult = true;
}

//=========================================================================
//	FUNCTION:	HandleRedoCommand
//	
//	VISIBLITY:	Private
//=========================================================================
template <class UNDO_POLICY, class PRINT_POLICY>
void CP_Document<UNDO_POLICY, PRINT_POLICY>::HandleRedoCommand( OSStatus& inOutStatus,
	CP_CommandNo& /*inCommand*/ )
{	
	fUndoPolicy.HandleRedoCommand( inOutStatus );
}

CPLAT_End_Namespace_CPLAT

#endif	// _H_CP_Document_tmpl

