//=========================================================================
//
//	FILE:				CP_CGColorSpace.h
//	
//						Copyright  2005. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			A class to handle Quartz CGColorspaces.
//	
//	HISTORY:			1st Version - February 2005.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 271 $
//						Latest Checkout:  $Date: 2005-09-06 19:24:58 -0700 (Tue, 06 Sep 2005) $
//
//=========================================================================
#ifndef _H_CP_CGColorSpace
#define _H_CP_CGColorSpace
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

#if TARGET_OS_MAC && TARGET_RT_MAC_MACHO

	// CPLAT_Framework
CPLAT_Begin_Namespace_CPLAT

/*!
*	@class		CP_CGColorSpace
*	@brief		A class to handle Quartz CGColorspaces.
*/
class CP_EXPORT CP_CGColorSpace
{
public:
	//! @name Constructor / Destructor
	//@{
	//! Constructor.
										CP_CGColorSpace();
	//! Destructor.
	virtual								~CP_CGColorSpace() throw();
	//@}

	//! @name Getters
	//@{
										/*!
										*	Return the CGColorSpaceRef maintained by this object.
										*	
										*	@exception	none
										*	
										*	@return		CGColorSpaceRef		The CGColorSpaceRef for this object.
										*/
			CGColorSpaceRef				GetColorSpaceRef() const				{ return( fColorSpaceRef ); }
	//@}

protected:

private:
			
	// class data
private:
	CGColorSpaceRef						fColorSpaceRef;		/*! The CGColorSpaceRef for this object. */
};

CPLAT_End_Namespace_CPLAT

#endif	// TARGET_OS_MAC && TARGET_RT_MAC_MACHO

#endif	// _H_CP_CGColorSpace

