//=========================================================================
//
//	FILE:				CP_StCGStateSaver.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			Stack based class to save and restore the current state
//						of a CGContextRef.
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 2 $
//						Latest Checkout:  $Date: 2004-12-21 19:40:38 -0800 (Tue, 21 Dec 2004) $
//
//=========================================================================
#ifndef _H_CP_StCGStateSaver
#define _H_CP_StCGStateSaver
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

#if TARGET_OS_MAC

	// CPLAT_Framework
#include "CP_Canvas.h"
#include "CP_Graphics_Imp_Quartz_defs.h"

CPLAT_Begin_Namespace_CPLAT

class CP_EXPORT CP_StCGStateSaver : public CP_NoCopy
{
public:
	//! @name Constructor / Destructor
	//@{
	//! Constructor.
										CP_StCGStateSaver( CGContextRef inContextRef );
										CP_StCGStateSaver( CP_Canvas& inDestCanvas );
	//! Destructor.
	virtual								~CP_StCGStateSaver();
	//@}

	//! @name Save / Restore
	//@{
			void						Save();
			void						Restore();
	//@}

	// class data
private:
	CGContextRef						fContextRef;		/* ! CGContextRef we save state for. */
		
	#if ! TARGET_RT_MAC_MACHO
		CFBundleRef						fAppServicesFrameworkBundle;

			// Graphics State
		CGContextSaveGStateFuncPtr		fSaveGStateFP;		/* ! Function ptr to allow call from CFM. */
		CGContextRestoreGStateFuncPtr	fRestoreGStateFP;	/* ! Function ptr to allow call from CFM. */
	#endif
	
//========================================================================
// Platform specific routines
//========================================================================
#if TARGET_OS_MAC
#endif

#if TARGET_OS_WIN32
#endif

#if TARGET_OS_LINUX
#endif
};

CPLAT_End_Namespace_CPLAT

#endif	// TARGET_OS_MAC

#endif	// _H_CP_StCGStateSaver

