//=========================================================================
//
//	FILE:				CP_MDIFrameWindow.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			DESCRIBE CLASS HERE
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 2 $
//						Latest Checkout:  $Date: 2004-12-21 19:40:38 -0800 (Tue, 21 Dec 2004) $
//
//=========================================================================
#ifndef _H_CP_MDIFrameWindow
#define _H_CP_MDIFrameWindow
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

#if TARGET_OS_WIN32

	// CPLAT_Framework
#include "CP_EventHandler_Imp_MDIFram.h"
#include "CP_Window.h"

CPLAT_Begin_Namespace_CPLAT

/*!
*	\class		CP_CP_MDIFrameWindow
*	\brief		1 LINE BRIEF DESCRIPTION HERE
*	
*				DETAILED DESCRIPTION BEGINS HERE
*/
class CP_EXPORT CP_MDIFrameWindow : public CP_Window
{
public:
	//! @name Constructor / Destructor
	//@{
	//! Constructor.
										CP_MDIFrameWindow();
	//! Destructor.
	virtual								~CP_MDIFrameWindow() throw();
	//@}

	//! @name Events
	//@{
	virtual	LRESULT						HandleWinProcMessage(
												HWND inHwnd,
												UINT inIMsg,
												WPARAM inWParam,
												LPARAM inLParam );
	//@}

	//! @name Windows Messages
	//@{
			LRESULT	CALLBACK			HandleMDIFrameWinProcMessage(
												HWND hwnd,
												UINT iMsg,
												WPARAM wParam,
												LPARAM lParam );
	//@}

protected:
	//! @name Initialization
	//@{
	virtual	void						CreatePlatformImp(
												const CP_Point& inUpperLeft,
												const CP_Size& inContentSize,
												const CP_String& inWindowTitle,
												const CP_WindowTypeBase& inWindowType );
	//@}

	//! @name Events
	//@{
										/*!
										*	Returns the CP_EventHandler that handles events for this window.
										*	
										*	@exception	none
										*	
										*	@return		CP_EventHandler&		Returns a reference to our event handler.
										*/
	virtual	CP_EventHandler&			GetEventHandler()											{ return( fEventHandler ); }

			void						InitEventHandler( CP_EventHandler& inEventHandler );
	//@}

private:
	//! @name Events
	//@{
			void						HandleCloseEvent( CP_Event_Base& inEvent );
	//@}

	// class data
protected:

private:
	CP_EventHandler_Imp_MDIFrame		fEventHandler;			/*! CPLAT event handler object that handles all window events. */
};

LRESULT CALLBACK MDIFrameWndProc( HWND inHwnd, UINT inMsg, WPARAM inWParam, LPARAM inLParam );

CPLAT_End_Namespace_CPLAT

#endif	// TARGET_OS_WIN32

#endif	// _H_CP_MDIFrameWindow

