//=========================================================================
//
//	FILE:				CP_FrameworkHeaders.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			Includes for most CPLAT framework headers.
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 194 $
//						Latest Checkout:  $Date: 2005-05-25 22:20:49 -0700 (Wed, 25 May 2005) $
//
//=========================================================================
#ifndef _H_CP_FrameworkHeaders
#define _H_CP_FrameworkHeaders
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

	// CPLAT_Framework headers
#include "CP_String.h"
#include "CP_TextEncoder.h"
#include "CP_Types.h"

#if !CP_CORE_ONLY // JUM 2004-11-25
	#include "CP_AboutBox.h"

	#include "CP_Alerts.h"							// Alerts
	#include "CP_AskSaveChangesDialog.h"

	#include "CP_Application.h"						// Application
#endif // !CP_CORE_ONLY

#include "CP_M_CommandHandler.h"					// Commands

#if !CP_CORE_ONLY // JUM 2004-11-25
	#include "CP_DataSource.h"
#endif

#include "CP_Debugging.h"							// Debugging
#include "CP_Exceptions.h"

#if !CP_CORE_ONLY // JUM 2004-11-25
	#include "CP_Dialog.h"

	#include "CP_Document.h"						// Documents

	#include "CP_DragDrop.h"						// Drag and Drop
	#include "CP_M_DragSource.h"
	#include "CP_M_DragTarget.h"

	#include "CP_Event.h"							// Event / Command Handling
	#include "CP_Message.h"
#endif

#include "CP_File.h"								// Files / File System
#include "CP_FileFilter.h"
#include "CP_FileIterator.h"
#include "CP_FileSystemSpec.h"
#include "CP_FileSystem.h"
#if !CP_CORE_ONLY // JUM 2004-11-25
	#include "CP_FileSystemDialogsBase.h"
	#include "CP_FileSystemDialogsReply.h"
	#include "CP_GetDirectoryDialog.h"
	#include "CP_GetFileDialog.h"
#endif

#include "CP_Point.h"								// Geometry
#include "CP_Rect.h"
#if !CP_CORE_ONLY // JUM 2004-11-25
	#include "CP_Region.h"
#endif // !CP_CORE_ONLY
#include "CP_Size.h"

#include "CP_DefaultHeap.h"							// Memory
#include "CP_HandleBlock.h"
#include "CP_Heap.h"
#include "CP_New.h"

#if !CP_CORE_ONLY // JUM 2004-11-25
	#include "CP_Menu.h"							// Menus
	#include "CP_MenuBar.h"

	#include "CP_Canvas.h"
	#include "CP_Clip.h"
	#include "CP_Font.h"
	#include "CP_Numeric.h"
	#include "CP_OSIcon.h"
	#include "CP_OSPicture.h"
	#include "CP_StPenStateSaver.h"
	#include "CP_StPortSaver.h"
	#include "CP_QuickDraw_GDI_Utility.h"
	#include "CP_RGBColor.h"
#endif // !CP_CORE_ONLY

#include "CP_FileStream.h"							// Streams
#include "CP_HandleBlockStream.h"
#include "CP_InStream.h"
#include "CP_OutStream.h"
#include "CP_PtrBlockStream.h"

#include "CP_Environment.h"
#include "CP_M_ReferenceCounted.h"
#include "CP_Utility.h"
#include "CP_UUID.h"
#if !CP_CORE_ONLY // JUM 2004-11-25
	#include "CP_DeviceLoop.h"
	#include "CP_ImageList.h"
	#include "CP_Printer.h"

	#include "CP_BevelButton.h"						// Views -- controls
	#include "CP_ChasingArrows.h"
	#include "CP_CheckBox.h"
	#include "CP_IconControl.h"
	#include "CP_PictureControl.h"
	#include "CP_PlatformControl.h"
	#include "CP_PopupMenu.h"
	#include "CP_PushButton.h"
	#include "CP_RadioButton.h"
	#include "CP_ScrollBar.h"
	#include "CP_Slider.h"

	#include "CP_DisclosureTriangle.h"
	#include "CP_ImageWell.h"
	#include "CP_LittleArrows.h"
	#include "CP_Placard.h"
	#include "CP_TextGroupBox.h"
	#include "CP_PrintView.h"
	#include "CP_ProgressBar.h"
	#include "CP_Scroller.h"
	#include "CP_Separator.h"
	#include "CP_TabView.h"
	#include "CP_View.h"
	#include "CP_WindowHeader.h"
	#include "CP_WindowListHeader.h"

	#include "CP_StaticText.h"						// Views -- text
	#include "CP_TextView.h"

	#include "CP_DocumentWindow.h"					// Windows
	#include "CP_Window.h"
#endif // !CP_CORE_ONLY

	// MacOS
#include "CP_CFBundle.h"
#include "CP_CFDictionary.h"
#include "CP_CFObject.h"
#include "CP_CFURL.h"

#endif	// _H_CP_FrameworkHeaders

